//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
#define DEBUG
#define TRACE

using System ;
using System.Diagnostics ;
using Bugslayer ;


public class HappyAppy
{
    public static void Baz ( bool bAssert )
    {
        if ( true == bAssert )
        {
            Debug.Assert ( false ) ;
            Trace.Assert ( false ) ;
        }

    }

    public static void Bar ( bool bAssert )
    {
        Baz ( bAssert ) ;
    }
    public static void Foo ( bool bAssert )
    {
        Bar ( bAssert ) ;
    }

    public static void Main ( )
    {
        Debug.Listeners.Remove ( "Default" ) ;
        BugslayerTraceListener btl = new BugslayerTraceListener ( ) ;
        // This will always cause a message box to appear even if
        // DEBUG is not defined!
        btl.Fail ( "Hello!" ) ;
        Debug.Listeners.Add ( btl ) ;

        Foo ( true ) ;

        Baz ( false ) ;
        Baz ( true ) ;
        Baz ( false ) ;


        Debug.WriteLine ( btl , "WriteLine ( Object , String )" ) ;
        Debug.WriteLine ( "WriteLine ( String )" ) ;
        Debug.WriteLine ( btl ) ;
        Debug.WriteLine ( "WriteLine " , "( String , String )" ) ;

        btl.ShowEventLogTraces = true ;
        btl.EventSource = "MyLog" ;

        Debug.WriteLine ( btl , "WriteLine ( Object , String )" ) ;
        Debug.WriteLine ( "WriteLine ( String )" ) ;
        Debug.WriteLine ( btl ) ;
        Debug.WriteLine ( "WriteLine " , "( String , String )" ) ;

        Debug.Assert ( false ) ;

        Console.WriteLine ( "Check that the MyLog key is in the registry" ) ;
        Console.WriteLine ( "Press any key to delete it!" ) ;
        Console.Read ( ) ;
        btl.EventSource = null ;
        BugslayerTraceListener.SafeEventLogDelete ( "MyLog" ) ;

        BugslayerTraceSwitch Switcher ;

         Switcher = new BugslayerTraceSwitch ( "TestSwitch"     ,
                                               "My test Switch" ,
                                               "Foo.txt"         ) ;
    }

    public static void TestFunc ( bool Flag )
    {
        if ( true == Flag )
        {
            Console.WriteLine ( "TestFunc called!" ) ;
        }
        else
        {
            Console.WriteLine ( "TestFunc called with false!" ) ;
        }
    }
}


