//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;

namespace ValidatingData
{
	/// <summary>
	/// Summary description for DataGridImageColumn.
	/// </summary>
	public class DataGridImageColumn : DataGridColumnStyle
	{
		public DataGridImageColumn()
		{
			Debug.WriteLine(string.Format("DataGridImageColumn()"));
		}
		protected override void Abort(int row)
		{
			Debug.WriteLine(string.Format("Abort({0})", row));
		}
		protected override bool Commit(CurrencyManager dataSource, int row)
		{
			Debug.WriteLine(string.Format("Commit({0})", row));
			return true;
		}
		protected override void Edit(CurrencyManager source, int row, Rectangle bounds, bool readOnly, string instantText, bool isVisible)
		{
			Debug.WriteLine(string.Format("Edit({0})", row));
		}
		protected override int GetMinimumHeight()
		{
			int minimumHeight = 0;
			Debug.WriteLine(string.Format("GetMinimumHeight() returning {0}", minimumHeight));
			return minimumHeight;
		}
		protected override int GetPreferredHeight(Graphics g, object value)
		{
			int minimumHeight = 0;
			Debug.WriteLine(string.Format("GetPreferredHeight() returning {0}", minimumHeight));
			return minimumHeight;
		}
		protected override Size GetPreferredSize(Graphics g, object value)
		{
			Size size = new Size(512, 512);
			Debug.WriteLine(string.Format("GetPreferredSize() returning {0}X{1}", size.Width, size.Height));
			return size;
		}
		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int row)
		{
			Debug.WriteLine(string.Format("Paint({0})}", row));
		}
		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int row, bool alignRight)
		{
			Debug.WriteLine(string.Format("Paint({0})}", row));
		}
	}
}
